/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2005-2008 by TAKAGI Nobuhisa
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */

/*!
 *  \file   toppers/text_line.hpp
 *  \brief  eLXgf[^̍sɊւ錾`
 *
 *  ̃t@CŒ`NX
 *  \code
 *  struct text_line;
 *  struct basic_line_buf< CharT, Traits, Allocator >;
 *  \endcode
 */
#ifndef TOPPERS_TEXTLINE_HPP_
#define TOPPERS_TEXTLINE_HPP_

#include <iosfwd>
#include <string>
#include <algorithm>
#include "toppers/config.hpp"

namespace toppers
{

  /*!
   *  \struct text_line text_line.hpp "toppers/text_line.hpp"
   *  \brief  t@Cƍsԍ̕ێNX
   */
  struct text_line
  {
    std::string file;   //!< t@C
    long line;          //!< sԍi1`j

    /*!
     *  \brief  ftHgRXgN^
     */
    text_line()
      : line( 0 )
    {
    }
    /*!
     *  \brief  RXgN^
     *  \param  filename  t@C
     *  \param  lineno    sԍ
     */
    explicit text_line( std::string const& filename, long lineno = 0 )
      : file( filename ), line( lineno )
    {
    }
    /*!
     *  \brief  RXgN^
     *  \param  filename  t@C
     *  \param  lineno    sԍ
     */
    explicit text_line( char const* filename, long lineno = 0 )
      : file( filename ), line( lineno )
    {
    }
    /*!
     *  \brief  IuWFNǧ
     *  \param  other   Ώۂ̃IuWFNg
     */
    void swap( text_line& other ) throw()
    {
      std::swap( line, other.line );
      file.swap( other.file );
    }
  };

  /*!
   *  \struct line_buf text_line.hpp "toppers/text_line.hpp"
   *  \brief  1 seLXg̊ǗNX
   */
  template
  <
    typename CharT,
    class Traits = std::char_traits< CharT >,
    class Allocator = std::allocator< CharT >
  >
  struct basic_line_buf
  {
    typedef std::basic_string< CharT, Traits, Allocator > string_type;

    string_type buf; //!< sf[^\
    text_line line;  //!< sԍ

    /*!
     *  \brief  ftHgRXgN^
     */
    basic_line_buf()
    {
    }
    /*!
     *  \brief  RXgN^
     *  \param  line  sԍ
     */
    basic_line_buf( text_line const& line )
      : line( line )
    {
    }
    /*!
     *  \brief  RXgN^
     *  \param  line  sԍ
     *  \param  data  sf[^
     */
    basic_line_buf( text_line const& line, string_type const& data )
      : buf( data ), line( line )
    {
    }
  };

  //! char ł 1 seLXgǗNX
  typedef basic_line_buf< char > line_buf;

  /*!
   *  \brief  Ce[^ێsԍ̎擾
   *  \param  iter  Ce[^
   *  \return sԍւ̎QƂԂ
   *
   *  iter Ŏw肵Ce[^sԍێĂȂA̍sԍԂ܂B
   *  sԍێĂȂꍇ̓_~[IuWFNgւ̎QƂԂ܂B
   */
  template < class Iterator >
  inline text_line const& get_text_line( Iterator iter )
  {
    static text_line dummy;
    return dummy;
  }

}

#endif  // ! TOPPERS_TEXTLINE_HPP_
